Subject: Re: Public NNCP Relay is now available

From: Sergey Matveev <[email-masked]>
Date: Wed, 4 Aug 2021 11:14:18 +0300

Greetings!

*** John Goerzen [2021-08-02 21:34]:
>what are we building here?

This is the main question! :-)

>So, what are we building?  Maybe:
>1. A simple relay for people to exchange data with their own nodes;
>2. [...]
>For 1 or 2, a public nodelist is barely even necessary; you configure your
>own machines as appropriate.

Agreed that nodelist is barely necessary there.

>3. A larger peer-to-peer network as in UUCPNet or FidoNet that builds a
>decentralized network atop the Internet (or other transports)

Currently I am in the state that we (probably only I?) definitely do not
want that. I thought about FTN-networks all the time since the very
beginning of NNCP project. And honestly and frankly I just fear to think
in that direction (of more or less global-scale network), because I see
huge quantity of projects having too high and too longterm and too
complicated targets -- and they fail because of lack of time, lack of
interest after a while and various other reasons. I prefer to have not
so feature-full thing, but that could be treated more or less completed
and good enough for some clearly defined use-cases.

Making FTN-like network from NNCP is not possible because of decisions
of authentication of everyone and everything. You correctly noted that
you even can not receive anything without explicit knowledge of sender's
public keys. And I very like that decision anyway: friend-to-friend
networks are more secure, more simple, and so on. And of course they
have got some drawbacks impeding some tasks solving.

>So if we're going to build #3, what we need is for each node to be able to
>compute the via lines for the other nodes in the network *from its own
>perspective*.

Yeah, that is some kind of full-fledged dynamic routing. And moreover,
in FTN networks every node can directly connect to any other node, that
currently is not possible without presharing their public keys. Globally
distributed nodelist with public keys can help in that, but in that case
you will use system with some kind of automatic nodes discovery/knowledge.
I know that even completely cryptography-less systems like FTN existed
with millions of users, but I really do want much more secure and
authenticated/trusted thing. However currently there is already
multicast areas functionality where you can transit packets without
knowing the sender of area packet.

That is (global-scale network, without the forced need of
friend-to-friend connectivity) much more complicated tasks. Possibly
that kind of network can be built atop of NNCP, using it as a
node-to-node transport, and processing tossed packets with some
completely different routing algorithms and formats. But NNCP itself is
definitely useful at least for my needs (store-and-forward helpers), and
NNCP-FTN is the thing which I definitely not in need :-). It can be
interesting as a hobby, just-for-run project, some kind of challenge,
but not for the really appearing problems solution. Of course this is
only my personal opinion.

>Fortunately we actually have such a tool: pathalias, from the old UUCP days.
>And, it's even still maintained! https://gitlab.com/uucpnet/pathalias

Very interesting tool! Definitely could be useful even now. Will look at
it closer soon. Thanks for pointing!

-- 
Sergey Matveev (http://www.stargrave.org/)
OpenPGP: CF60 E89A 5923 1E76 E263  6422 AE1A 8109 E498 57EF